#!/usr/bin/env python
# vim: set ts=4 sts=4 sw=4 textwidth=92:

import PAR2Set
from RarslaveCommon import *

#
# This is an new-style rar type
#
# It will detect sets like the following:
# X.par2
# X.vol0+1.par2
# X.vol1+2.par2
# X.part01.rar
# X.part02.rar
# X.part03.rar
#
# OR
#
# ABC.part01.rar
# ABC.part02.rar
# ABC.part03.rar
#
# Where the PAR2 files protect all files that do not match in basename
# with the PAR2 file itself.
#

def detect_NEWRAR (name_files, prot_files):
	return has_a_match ('^.*\.part0*1\.rar$', prot_files)


class PAR2Set_NEWRAR (PAR2Set.PAR2Set):

	def __repr__ (self):
		return 'NEWRAR'

	def find_extraction_heads (self):
		return find_matches ('^.*\.part0*1\.rar$', self.all_files)

	def extraction_function (self, file, todir):
		assert os.path.isfile (file)
		assert os.path.isdir (todir)

		RAR_CMD = config_get_value ('commands', 'unrar')

		cmd = '%s \"%s\"' % (RAR_CMD, file)
		ret = run_command (cmd, todir)

		# Check error code
		if ret != 0:
			return -EEXTRACT

		return SUCCESS

